package javax.rtgedition;

/***********************************************
 *  RTG, University of Pennsylvania
  * Author:	Dave Arney	11/07/01
  **********************************************/

import java.util.Date;

public abstract class Clock {
/* Constructor */
  public Clock() {
  }

  /* Public Methods */

  /* Returns: an instance of the default Clock
  */
  public static Clock getRealtimeClock(){
  	return RealtimeClock.getRealtimeClock();
  }

/* Returns: A RelativeTime object representing the resolution of this */
  public abstract RelativeTime getResolution();

/* Returns: An AbsoluteTime that represents the current time of this */
 public AbsoluteTime getTime(){
	AbsoluteTime aTime =  new AbsoluteTime();
	getTime(aTime);
	return aTime;
  }

/* Parameters:
* 	time: The AbsoluteTime object which will have its time changed. If null, nothing happens.
 * Returns the current time in an existing object. */
  public abstract void getTime(AbsoluteTime time);

/* Parameters:
* 	resolution: The new resolution of this */
  public abstract void setResolution(RelativeTime resolution);
} 
